/* 
 * File:   LCD.h
 * Author: chengo_cc
 *
 * Created on 30 December 2015, 1:08 AM
 */

#ifndef LCD_H
//------------------------------------------------------------------------------
#include "prototypes.h"
//-----------------------Follow Datasheet instructions--------------------------
void LCD_init()
{
  RS_dir = 0;
  EN_dir = 0;
  D4_dir = 0;
  D5_dir = 0;
  D6_dir = 0;
  D7_dir = 0;

  LCD_command(home);
  LCD_command(function_set);   //One line mode
  LCD_command(display_on);
  LCD_command(auto_increment);
}
//------------------------------------------------------------------------------
void LCD_write(char data)
{
  D4 = ((data>>0) & 0x01) ? 1 : 0;
  D5 = ((data>>1) & 0x01) ? 1 : 0;
  D6 = ((data>>2) & 0x01) ? 1 : 0;
  D7 = ((data>>3) & 0x01) ? 1 : 0;
}
//------------------------------------------------------------------------------
void LCD_command(char command)
{
  char higherNible =  (command & 0xF0) >> 4;
  char lowerNible =    command & 0x0F;

  RS = 0;                           //Instruction register ( commands ).
  LCD_write(higherNible);
  latch();
  LCD_write(lowerNible);
  latch();
}
//------------------------------------------------------------------------------
void LCD_data(char data)
{
  char higherNible =  (data & 0xF0) >> 4;
  char lowerNible =    data & 0x0F;

  RS = 1;                           //Data register  ( Strings and characters ).
  LCD_write(higherNible);
  latch();
  LCD_write(lowerNible);
  latch();
}
//------------------------------------------------------------------------------
void LCD_string(int row, int column, char text[])
{
  LCD_command(screenPos[row][column]);  //Set co-ordinates.
  while(*text)
  {
    LCD_data(*text++);
  }
}
//------------------------------------------------------------------------------
void LCD_character(int row, int column, char character)
{
  LCD_command(screenPos[row][column]);
  LCD_data(character);
}
//------------------------------------------------------------------------------
void latch()
{
  EN  = 1;
  EN  = 0;
}
//------------------------------------------------------------------------------
#define	LCD_H

#ifdef	__cplusplus
extern "C" {
#endif




#ifdef	__cplusplus
}
#endif

#endif	/* LCD_H */