/* 
 * File:   ADC.h
 * Author: chengo_cc
 *
 * Created on 29 December 2015, 9:55 PM
 */

#ifndef ADC_H
//------------------------------------------------------------------------------
void ADC_init()
{
  ADCON0 = 0xC1; //<ADCS1:ADCS0>internal A/D RC oscillator,<CHS2:CHS0>Channel 0 (AN0),(ADON) A/D converter module is powered up
  ADCON1 = 0x80; //ADFM = 1 (Right justified. Six (6) Most Significant bits of ADRESH are read as 0)
}
//------------------------------------------------------------------------------
int ADC_read(unsigned char channel)
{
  if(channel > 7)          //If Invalid channel selected
     return 0;
  ADCON0 =  ADCON0 & 0xC1;          //Clearing the Channel Selection Bits to make Channel 0 as default Channel
  ADCON0 =  ADCON0 | (channel<<3);    //Setting the required Bits: CHS2 CHS1 CHS0

  delay(4);
  GODONE = 1;
  while(GODONE)
     {/*wait for ADC completion*/};

  return ((ADRESH<<8)+(ADRESL));
}
//------------------------------------------------------------------------------
#define	ADC_H

#ifdef	__cplusplus
extern "C" {
#endif




#ifdef	__cplusplus
}
#endif

#endif	/* ADC_H */