/* 
 * File:   USART.h
 * Author: chengo_cc
 *
 * Created on 29 December 2015, 9:53 PM
 */

#ifndef USART_H
//------------------------------------------------------------------------------
void USART_init(unsigned int baudRate)
{
  TXSTA = 0xB0;   // Master mode, Set TXEN,SYNC = 1:Synchronous mode
  RCSTA = 0x80;   // Set SPEN.
  SPBRG = (int)((XTAL_FREQ/baudRate)/4) - 1; //Formula according to Datasheet (For Highspeed mode)
  TRISC6 = 1;     // DT: Data
  TRISC7 = 1;     // CK: Clock
}
//------------------------------------------------------------------------------
void USART_write(char data)
{
  while(!TRMT);  //Poll if TSR is Full  TRMT   TXIF
  TXREG = data;
}
//------------------------------------------------------------------------------
void USART_string(char text[])
{
  while(*text)
  {
    USART_write(*text++);
  }
}
//------------------------------------------------------------------------------
char USART_read()
{
  while(!RCIF);
  return RCREG;
}
//------------------------------------------------------------------------------
#define	USART_H

#ifdef	__cplusplus
extern "C" {
#endif




#ifdef	__cplusplus
}
#endif

#endif	/* USART_H */